Package: demoShiny
Title: Runs a 'Shiny' App as Demo or Lists All Demo 'Shiny' Apps
Version: 0.1
Authors@R: 
  person("Sigbert", "Klinke", email="sigbert@hu-berlin.de", role=c("aut", "cre"))
Description: Mimics the demo functionality for 'Shiny' apps in a package. Apps stored to the package subdirectory inst/shiny can be called by demoShiny(topic).
Depends: shiny
License: GPL-3
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.0.2
Suggests: knitr, rmarkdown
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2020-01-13 11:58:23 UTC; sigbert
Author: Sigbert Klinke [aut, cre]
Maintainer: Sigbert Klinke <sigbert@hu-berlin.de>
Repository: CRAN
Date/Publication: 2020-01-16 10:30:07 UTC
Built: R 4.6.0; ; 2026-04-28 16:32:12 UTC; unix

# demoShiny #

Runs a Shiny app as demo or shows an overview of all Shiny demo apps related to a `topic`. 
If more than one app relates to `topic` a list of apps is returned otherwise the app is run.
For more details see `vignettes('demoShiny')`.

```r
# collect all apps of loaded packages
demoShiny() 
# collect all apps of the package demoShiny or with the name demoShiny
demoShiny('demoShiny') 

```

library(shiny)
library(shinydashboard)
library(shinyWidgets)
library(shinyExample)

toNum <- function(x, min=-Inf, max=+Inf) {
  x <- suppressWarnings(as.numeric(x))
  if (length(x)!=1) return(NA)
  if(is.na(x)) return(NA)  
  if (x<min) return(NA)  
  if (x>max) return(NA)
  x 
}

library("dbscan")
library("rio")
x <- scale(import("BANK2.sav"))



ui <- dashboardPage(
  dashboardHeader(title="", titleWidth=, disable=),
  dashboardSidebar(collapsed=, width=, disable=,
                   uiOutput("outputId"="UIeps"),
                   uiOutput("outputId"="UIpts"),
                   shiny::tags$div(align="center",
                                   shiny::tags$hr(),
                                   shiny::tags$a(href = 'https://github.com/sigbertklinke/shinyExample', 'Created with shinyExample'),
                                   shiny::tags$br(),
                                   shiny::tags$a(target="_blank", href="https://www.wihoforschung.de/de/flipps-1327.php",  'Supported by BMBF')
                   )
  ),
  dashboardBody(
    shiny::plotOutput("outputId"="plot",
                      "width"="100%",
                      "height"="400px",
                      "inline"=FALSE)
  )
)

server <- function(input, output, session) {
  seed <- list(inBookmark=FALSE)
  
  onBookmark(function(state) {
    state$seed <- seed
  })
  
  onRestore(function(state) {
    seed <- state$seed
    seed$inBookmark <- TRUE
  })
  
  onRestored(function(state) {
    seed$inBookmark <- FALSE
  })
  
  onStop(function() {
#   if (isLocal()) {
#      count <- getMMstat('lang', 'stats', 'count')
#      cat(sprintf('gettext("%s"); // %.0f\n', names(count), count))
#    }
  })
  
  value <- function(val) {
    param <- substitute(val)
    if(param=="input$eps") { v<-toNum(val, min=0, max=1); if(is.na(v)) return(0.5) else return(v) }
    if(param=="input$pts") { v<-toNum(val, min=2, max=10); if(is.na(v)) return(5) else return(v) }
    return(val)
  }
  
  observe({
    
    sel  <- value(isolate(input$eps))
    shiny::updateSliderInput("session"=session,
                             "inputId"="eps",
                             "label"=("Core distance"),
                             "value"=sel,
                             "min"=0,
                             "max"=1,
                             "step"=0.01)
  })
  observe({
    
    sel  <- value(isolate(input$pts))
    shiny::updateSliderInput("session"=session,
                             "inputId"="pts",
                             "label"=("Minimal neighbour "),
                             "value"=sel,
                             "min"=2,
                             "max"=10,
                             "step"=1)
  })
  
  output$plot <- shiny::renderPlot({
    
    #/home/sigbert/syncthing/projekte/R/shinyApp/inst/app/dbscan/dbscan2.R
    # shinyApp/inst/app/dbscan/dbscan2.R
    db  <- dbscan(x[,c(4,6)], value(input$eps), value(input$pts))
    col <- c('grey', rainbow(max(db$cluster)))
    plot(x[,c(4,6)], col=col[1+db$cluster], pch=19, asp=TRUE)
  })
  output$UIeps<- renderUI({
    shiny::sliderInput("inputId"="eps",
                       "label"=("Core distance"),
                       "min"=0,
                       "max"=1,
                       "value"=0.5,
                       "step"=0.01,
                       "round"=FALSE,
                       "ticks"=TRUE,
                       "animate"=FALSE,
                       "width"=NULL,
                       "sep"=",",
                       "pre"=NULL,
                       "post"=NULL,
                       "timeFormat"=NULL,
                       "timezone"=NULL,
                       "dragRange"=TRUE)
  })
  output$UIpts<- renderUI({
    shiny::sliderInput("inputId"="pts",
                       "label"=("Minimal neighbour "),
                       "min"=2,
                       "max"=10,
                       "value"=5,
                       "step"=1,
                       "round"=FALSE,
                       "ticks"=TRUE,
                       "animate"=FALSE,
                       "width"=NULL,
                       "sep"=",",
                       "pre"=NULL,
                       "post"=NULL,
                       "timeFormat"=NULL,
                       "timezone"=NULL,
                       "dragRange"=TRUE)
  })
}

shinyApp(ui, server)

library(shiny)
library(shinydashboard)
library(shinyWidgets)
library(shinyExample)

library("scagnostics")
data(Boston, package = "MASS")
scag <- scagnostics(Boston)


getList <- function(...) { list(...) }

toInt <- function(x, min=-Inf, max=+Inf) {
  x <- suppressWarnings(as.integer(x))
  if (length(x)!=1) return(NA_integer_)
  if(is.na(x)) return(NA_integer_)
  if (x<min) return(NA_integer_)  
  if (x>max) return(NA_integer_)  
  x
}

toNum <- function(x, min=-Inf, max=+Inf) {
  x <- suppressWarnings(as.numeric(x))
  if (length(x)!=1) return(NA)
  if(is.na(x)) return(NA)  
  if (x<min) return(NA)  
  if (x>max) return(NA)
  x 
}

ui <- dashboardPage(
  dashboardHeader(title="", titleWidth=, disable=),
  dashboardSidebar(collapsed=, width=, disable=,
                   uiOutput("outputId"="UIcoef"),
                   uiOutput("outputId"="UIindex"),
                   shiny::tags$div(align="center",
                                   shiny::tags$hr(),
                                   shiny::tags$a(href = 'https://github.com/sigbertklinke/shinyExample', 'Created with shinyExample'),
                                   shiny::tags$br(),
                                   shiny::tags$a(target="_blank", href="https://www.wihoforschung.de/de/flipps-1327.php",  'Supported by BMBF')
                   )
  ),
  dashboardBody(
    shiny::plotOutput("outputId"="plot",
                      "width"="100%",
                      "height"="400px",
                      "inline"=FALSE)
  )
)

server <- function(input, output, session) {
  seed <- list(inBookmark=FALSE)
  
  onBookmark(function(state) {
    state$seed <- seed
  })
  
  onRestore(function(state) {
    seed <- state$seed
    seed$inBookmark <- TRUE
  })
  
  onRestored(function(state) {
    seed$inBookmark <- FALSE
  })
  
  onStop(function() {
#    if (isLocal()) {
#      count <- getMMstat('lang', 'stats', 'count')
#      cat(sprintf('gettext("%s"); // %.0f\n', names(count), count))
#    }
  })
  
  value <- function(val) {
    param <- substitute(val)
    if(param=="input$coef") { v<-toInt(val, min=1); if(is.na(v)) return(1) else return(v) }
    if(param=="input$index") { v<-toNum(val, min=1, max=91); if(is.na(v)) return(1) else return(v) }
    return(val)
  }
  
  observe({
    
    sel<-value(isolate(input$coef))
    shiny::updateSelectInput("session"=session,
                             "inputId"="coef",
                             "label"=("Select coefficient"),
                             "choices"=getList("Outlying"=1,"Skewed"=2,"Clumpy"=3,"Sparse"=4,"Striated"=5,"Convex"=6,"Skinny"=7,"Stringy"=8,"Monotonic"=9),
                             "selected"=sel)
  })
  observe({
    
    sel  <- value(isolate(input$index))
    shiny::updateSliderInput("session"=session,
                             "inputId"="index",
                             "label"=("Plot number"),
                             "value"=sel,
                             "min"=1,
                             "max"=91,
                             "step"=NULL)
  })
  
  output$plot <- shiny::renderPlot({
    
    #/home/sigbert/syncthing/projekte/R/shinyApp/inst/app/scagnostics/scagnostics.R
    # shinyApp/inst/app/scagnostic/scagnostics.R
    vlist   <- strsplit(colnames(scag), ' * ', fixed=TRUE)
    coef    <- value(input$coef)
    pnr     <- value(input$index)
    o       <- order(scag[coef,])
    main    <- c("Outlying", "Skewed", "Clumpy", "Sparse", "Striated", "Convex", "Skinny", "Stringy", "Monotonic")
    main    <- sprintf("%s(%.0f): %.3f", main[coef], pnr, scag[coef,o[pnr]])
    par(mfrow=c(1,2))
    plot(Boston[,vlist[[o[pnr]]]], pch=19, main=main, cex=0.5)
    plot(Boston[,rev(vlist[[o[pnr]]])], pch=19, main=main, cex=0.5)
  })
  output$UIcoef <- renderUI({
    shiny::selectInput("inputId"="coef",
                       "label"=("Select coefficient"),
                       "choices"=getList("Outlying"=1,"Skewed"=2,"Clumpy"=3,"Sparse"=4,"Striated"=5,"Convex"=6,"Skinny"=7,"Stringy"=8,"Monotonic"=9),
                       "selected"=NULL,
                       "multiple"=FALSE,
                       "selectize"=TRUE,
                       "width"=NULL,
                       "size"=NULL)
  })
  output$UIindex<- renderUI({
    shiny::sliderInput("inputId"="index",
                       "label"=("Plot number"),
                       "min"=1,
                       "max"=91,
                       "value"=1,
                       "step"=NULL,
                       "round"=FALSE,
                       "ticks"=TRUE,
                       "animate"=FALSE,
                       "width"=NULL,
                       "sep"=",",
                       "pre"=NULL,
                       "post"=NULL,
                       "timeFormat"=NULL,
                       "timezone"=NULL,
                       "dragRange"=TRUE)
  })
}

shinyApp(ui, server)

library("shinydashboard")
library("cluster")

n  <- 25
cl <- matrix(rnorm(4*n), ncol=2)

ui <- dashboardPage(
  dashboardHeader(title = "Silhouette"),
  dashboardSidebar(
    sliderInput('cdist', 'Cluster distances', 0, 10, 5, 0.1),
    sliderInput('pdist', 'Point location', -7, 7, 0, 0.1),
    radioButtons('pid',  'Point belongs to', 
                choiceNames = c('red cluster', 'blue cluster'),
                choiceValues = 1:2)
  ),
  dashboardBody(
    plotOutput("cluster", height = 400)
  )
)

server <- function(input, output, session) {
  
  output$cluster <- renderPlot({
    x1 <- cl[1:n,1]-input$cdist/2
    y1 <- cl[1:n,2]
    x2 <- cl[n+(1:n),1]+input$cdist/2
    y2 <- cl[n+(1:n),2]
    par(mfrow=c(1,2))
    plot(0,0, type="n", xlim=c(-7,7), ylim=c(-3,3), asp=TRUE, main="Cluster assignment")
    abline(h=0, col="darkgrey")
    points(x1, y1, col="red", pch=19)
    points(x2, y2, col="blue", pch=19)  
    xp <- input$pdist
    yp <- 0
    points(xp, yp, col=ifelse(input$pid==1, "salmon", "lightblue"), pch=19)
    points(xp, yp, col="black")
    di  <- dist(cbind(c(xp, x1, x2), c(yp, y1, y2)))
    cl  <- as.integer(c(input$pid, rep(1, n), rep(2, n)))
    si  <- silhouette(cl, di)
    col <- c(ifelse(input$pid==1, 'salmon', 'lightblue'), rep("red", n), rep("blue", n))
    sic <- order(si[,'cluster'], -si[,'sil_width'])
    plot(si, col=col[sic], main="Silhouettes")
  })
}

shinyApp(ui, server)

launch.browser <- function(url) {
  # modify URL, which has no effect for app1 :(
  url <- sprintf('%s/?lang=%s', url, 'de')
  invisible(.Call("rs_shinyviewer", url, getwd(), 3))
}
#
library("shiny")
runApp(system.file('shiny', 'hist', package='demoShiny'), launch.browser=launch.browser)

library("shiny")

server <- function(input, output) {
  output$distPlot <- renderPlot({
    breaks <- seq(min(faithful$eruptions), max(faithful$eruptions), len=input$nbin+1)
    hist(faithful$eruptions, breaks=breaks, 
         xlab="Eruption time", ylab="Frequency", main="Old Faithful geyser")
  })
}

ui <- fluidPage(
  sidebarLayout(
    sidebarPanel(
      sliderInput("nbin", "Number of bins:", min = 2, max = 50, value = 20)
    ),
    mainPanel(plotOutput("distPlot"))
  )
)

shinyApp(ui = ui, server = server)

library(shiny)
library(shinydashboard)
library(shinyWidgets)
library(shinyExample)

toNum <- function(x, min=-Inf, max=+Inf) {
  x <- suppressWarnings(as.numeric(x))
  if (length(x)!=1) return(NA)
  if(is.na(x)) return(NA)  
  if (x<min) return(NA)  
  if (x>max) return(NA)
  x 
}

ui <- dashboardPage(
  dashboardHeader("title"="MM*Stat",
                  "titleWidth"=NULL,
                  "disable"=FALSE),
  dashboardSidebar("disable"=FALSE,
                   "width"=NULL,
                   "collapsed"=FALSE,
                   uiOutput("outputId"="UIr"),
                   uiOutput("outputId"="UIn"),
                   
                   shiny::tags$div(align="center",
                                   shiny::tags$hr(),
                                   shiny::tags$a(href = "https://github.com/sigbertklinke/shinyApp", "Created with shinyApp"),
                                   shiny::tags$br(),
                                   shiny::tags$a(target="_blank", href="https://www.wihoforschung.de/de/flipps-1327.php",  "Supported by BMBF"))),
  dashboardBody(shiny::plotOutput("outputId"="plot",
                                  "width"="100%",
                                  "height"="400px",
                                  "inline"=FALSE))
)

server <- function(input, output, session) {
  seed <- list(inBookmark=FALSE)
  
  onBookmark(function(state) {
    state$seed <- seed
  })
  
  onRestore(function(state) {
    seed <- state$seed
    seed$inBookmark <- TRUE
  })
  
  onRestored(function(state) {
    seed$inBookmark <- FALSE
  })
  
  onStop(function() {
    #if (isLocal()) {
    #  count <- getMMstat('lang', 'stats', 'count')
    #  cat(sprintf('gettext("%s"); // %.0f\n', names(count), count))
    #}
  })
  
  value <- function(val) {
    param <- substitute(val)
    if(param=="input$r") { v<-toNum(val, min=-1, max=1); if(is.na(v)) return(0) else return(v) }
    if(param=="input$n") { v<-toNum(val, min=30, max=500); if(is.na(v)) return(100) else return(v) }
    return(val)
  }
  
  observe({
    
    sel  <- value(isolate(input$r))
    shiny::updateSliderInput("session"=session,
                             "inputId"="r",
                             "label"=("r_xy"),
                             "value"=sel,
                             "min"=-1,
                             "max"=1,
                             "step"=0.01)
  })
  observe({
    
    sel  <- value(isolate(input$n))
    shiny::updateSliderInput("session"=session,
                             "inputId"="n",
                             "label"=("n"),
                             "value"=sel,
                             "min"=30,
                             "max"=500,
                             "step"=10)
  })
  
  output$plot <- shiny::renderPlot({
    
    #/home/sigbert/syncthing/projekte/R/shinyApp/inst/app/correlation/corr.R
    # shinyApp/inst/app/correlation/corr.R
    library("mvtnorm")
    n <- value(input$n)
    r <- value(input$r)
    repeat{
      out <- rmvnorm(n, mean = c(0,0), sigma = matrix(c(1,r,r,1), ncol=2))
      rr  <- cor(out)[1,2]
      if (abs(rr-r)<0.002) break
    }
    plot(out, pch=19, xlim=c(-3,3), ylim=c(-3,3), asp=TRUE, axes=FALSE, xlab="x", ylab="y",
         main=sprintf("Korrelation: %.2f", rr), cex=1/log10(n))
    box()
  })
  output$UIr<- renderUI({
    shiny::sliderInput("inputId"="r",
                       "label"=("r_xy"),
                       "min"=-1,
                       "max"=1,
                       "value"=0,
                       "step"=0.01,
                       "round"=FALSE,
                       "ticks"=TRUE,
                       "animate"=FALSE,
                       "width"=NULL,
                       "sep"=",",
                       "pre"=NULL,
                       "post"=NULL,
                       "timeFormat"=NULL,
                       "timezone"=NULL,
                       "dragRange"=TRUE)
  })
  output$UIn<- renderUI({
    shiny::sliderInput("inputId"="n",
                       "label"=("n"),
                       "min"=30,
                       "max"=500,
                       "value"=100,
                       "step"=10,
                       "round"=TRUE,
                       "ticks"=TRUE,
                       "animate"=FALSE,
                       "width"=NULL,
                       "sep"=",",
                       "pre"=NULL,
                       "post"=NULL,
                       "timeFormat"=NULL,
                       "timezone"=NULL,
                       "dragRange"=TRUE)
  })
}

shinyApp(ui, server)

## ----setup, include = FALSE----------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ------------------------------------------------------------------------
library("demoShiny")
demoShiny()

## ------------------------------------------------------------------------
demoShiny('demoShiny')

## ----eval=FALSE----------------------------------------------------------
#  # full topic
#  demoShiny('demoShiny::hist')
#  # if only one app is available then it will be run
#  demoShiny('hist')
#  # abbreviation for topics or packages can used
#  demoShiny('d::hist')

## ------------------------------------------------------------------------
list.files(system.file('shiny', package="demoShiny"), include.dirs=TRUE)

## ---- code=readLines(system.file('shiny', 'hist.R', package='demoShiny')), eval=FALSE----
#  launch.browser <- function(url) {
#    # modify URL, which has no effect for app1 :(
#    url <- sprintf('%s/?lang=%s', url, 'de')
#    invisible(.Call("rs_shinyviewer", url, getwd(), 3))
#  }
#  #
#  library("shiny")
#  runApp(system.file('shiny', 'hist', package='demoShiny'), launch.browser=launch.browser)

---
title: "demoShiny"
author: 
- name: "Sigbert Klinke" 
  email: sigbert@hu-berlin.de
date: "`r format(Sys.time(), '%d %B, %Y')`"
output: 
  html_document:
    toc: true
vignette: > 
  %\VignetteIndexEntry{demoShiny} 
  %\VignetteEngine{knitr::rmarkdown} 
  \usepackage[utf8]{inputenc} 
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

The aim of the package `demoShiny` is to mimic the `demo` functionality for Shiny apps for a package.

# Which Shiny apps are available?

With `demoShiny` you can get an overview about all apps from the loaded packages:

```{r}
library("demoShiny")
demoShiny()
```

The output is a data frame with `package::topic` and the file or directory which would be called by `demoShiny`.

You can question for specific apps:

```{r}
demoShiny('demoShiny')
```

It will deliver all demo apps of the package `demoShiny` **AND** all apps named `demoShiny`!

# How to run a single example app?

In case that for your topic is just one app available then no list will be returned but the Shiny demo app will be started:

```{r eval=FALSE}
# full topic
demoShiny('demoShiny::hist')
# if only one app is available then it will be run
demoShiny('hist')
# abbreviation for topics or packages can used
demoShiny('d::hist')
```

# App installation for a package in `inst/shiny`

If you develop a package then create under `inst` a directory `shiny`. 
Each subdirectory of `shiny` can contain one app. The name of the subdirectory is the topic name.

```{r}
list.files(system.file('shiny', package="demoShiny"), include.dirs=TRUE)
``` 

As you can see the `shiny` subdirectory of `demoShiny` contains several directories, e.g. `app1`, `silhouette`, and also a file `app1.R`. 

If you put an R file with the same name as a directory then the R file is sourced instead of calling
the app in the directory. The aim is to allow for a specific calls to the app, e.g. by setting URL parameters:

```{r, code=readLines(system.file('shiny', 'hist.R', package='demoShiny')), eval=FALSE}
```
